using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using System.Windows.Markup;
using System.Xml;

namespace Assets002ns
{
    /// <summary>
    /// Interaction logic for assets_v8Window.xaml
    /// </summary>
    public partial class assets_v8Window : WindowBase
    {

        public assets_v8Window()
        {
            InitializeComponent();
        }

        private Assets002ns.AssetsDBEntities assetsdbEntities = null;
        System.Windows.Data.CollectionViewSource asset_management2ViewSource = null;
        System.Data.Objects.ObjectQuery<Assets002ns.asset_management2> asset_management2Query = null;
        System.Windows.Data.CollectionViewSource maintenance_recordViewSource = null;
        System.Data.Objects.ObjectQuery<Assets002ns.maintenance_record> maintenance_recordQuery = null;

        private System.Data.Objects.ObjectQuery<Assets002ns.asset_management2>Getasset_management2Query(AssetsDBEntities assetsdbEntities)
          {
              // Auto generated code
              System.Data.Objects.ObjectQuery<Assets002ns.asset_management2> asset_management2Query = assetsdbEntities.asset_management2;
              //Update the query to include related table data in "maintenance_record". You can modify this code as needed.
              asset_management2Query = asset_management2Query.Include("maintenance_record"); // Returns an ObjectQuery.
              return asset_management2Query;
          }

        private System.Data.Objects.ObjectQuery<maintenance_record>Getmaintenance_recordQuery(AssetsDBEntities assetsdbEntities)
          {
              // Auto generated code
              System.Data.Objects.ObjectQuery<maintenance_record> maintenance_recordQuery = assetsdbEntities.maintenance_record;
              maintenance_recordQuery = maintenance_recordQuery.Include("asset_management2"); // Returns an ObjectQuery.
              return maintenance_recordQuery;
          }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            assetsdbEntities = new Assets002ns.AssetsDBEntities();
            // Load data into asset_management2. You can modify this code as needed.
            asset_management2ViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("asset_management2ViewSource")));
            asset_management2Query = this.Getasset_management2Query(assetsdbEntities);
            asset_management2ViewSource.Source = asset_management2Query.Execute(System.Data.Objects.MergeOption.PreserveChanges);
            maintenance_recordViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("maintenance_recordViewSource")));
            maintenance_recordQuery = this.Getmaintenance_recordQuery(assetsdbEntities);
            maintenance_recordViewSource.Source = maintenance_recordQuery.Execute(System.Data.Objects.MergeOption.PreserveChanges);
            this.ReBind();
        }
        protected internal override int TotalRecords
        {
            get 
            {
                var currentTable = assetsdbEntities.asset_management2.AsQueryable();
                int maxRecords = currentTable.Count();
                return maxRecords;
            }
        }
        
        protected internal override double CurrentRecordPosition
        {
            get
            {
                return (double)asset_management2ViewSource.View.CurrentPosition;
            }

            set
            {
                int newPosition = (int)value;
                var currentTable = assetsdbEntities.asset_management2.AsQueryable();   
                int maxRecords = currentTable.Count() - 1; 
                
                if(newPosition > maxRecords)
                {
                    newPosition = maxRecords;
                }

                asset_management2ViewSource.View.MoveCurrentToPosition(newPosition);
                NotifyPropertyChanged("CurrentRecordPosition");
            }
        }
        protected internal override void SaveRecords()
        {
            try
            {
                this.assetsdbEntities.SaveChanges();

            }
            catch (Exception)
            {
                //Error handling                
                throw;
            }
        }

        protected internal override void NewRecord()
        {
            try
            {
                var entity = assetsdbEntities.CreateObject<asset_management2>();
                assetsdbEntities.AddToasset_management2(entity);

            }
            catch (Exception)
            {
                //Error Handling
                throw;
            } 
            
            this.SaveRecords(); 
            asset_management2ViewSource.Source = asset_management2Query.Execute(System.Data.Objects.MergeOption.PreserveChanges);
            asset_management2ViewSource.View.MoveCurrentToLast();

            NotifyPropertyChanged("TotalRecords");
        }


        protected internal override void DeleteCurrentRecord()
        {
            try
            {
                var entity = asset_management2ViewSource.View.CurrentItem;
                assetsdbEntities.DeleteObject(entity);

            }
            catch (Exception)
            {
                //Error Handling        
                throw;
            }                    
            this.SaveRecords();
            asset_management2ViewSource.View.Refresh();
            NotifyPropertyChanged("TotalRecords");
        }

        protected internal override void MoveToNextRecord()
        {
            if (asset_management2ViewSource.View.CurrentPosition < ((CollectionView)asset_management2ViewSource.View).Count - 1)
            { 
                asset_management2ViewSource.View.MoveCurrentToNext(); 
            }
                this.SaveRecords();
            NotifyPropertyChanged("CurrentRecordPosition");
        }

        protected internal override void MoveToPreviousRecord()
        {
            if (asset_management2ViewSource.View.CurrentPosition > 0)
            {
                asset_management2ViewSource.View.MoveCurrentToPrevious();
            }
                this.SaveRecords();
            NotifyPropertyChanged("CurrentRecordPosition");
        }

        protected internal override void ReBind() 
        {
            this.Bind_menu_asset_management2__category();
            this.chkbx_asset_management2__book_value_RebindCheckBoxes();
            this.radio_asset_management2__category_RebindRadioButtons();
            this.chkbx_asset_management2__category_RebindCheckBoxes();
            this.radio_asset_management2__category3_RebindRadioButtons();
            this.chkbx_asset_management2__category4_RebindCheckBoxes();
            this.Bind_menu_asset_management2__category5();
            this.radio_asset_management2__category6_RebindRadioButtons();
            this.chkbx_maintenance_record__maint_condition3_RebindCheckBoxes();
            this.radio_maintenance_record__maint_condition4_RebindRadioButtons();
        }
     private void Bind_menu_asset_management2__category()
        {
            var data = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            if (data.category != null)
            {
                string category = data.category.TrimStart(' ');
                int i = 0;
                foreach (XmlElement item in menu_asset_management2__category.Items)
                {
                    if (item.InnerText.Equals(category))
                    {
                        menu_asset_management2__category.SelectedIndex = i;
                        return;
                    }
                    i++;
                }
            }
        }

        private void menu_asset_management2__category_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (asset_management2ViewSource != null)
            {
                 var item = (asset_management2)asset_management2ViewSource.View.CurrentItem;
                 if (item.category == null)
                 {
                    item.category = ((XmlElement)menu_asset_management2__category.SelectedItem).InnerText;
                }
            }
        }

        private void chkbx_asset_management2__book_value_Checked(object sender, RoutedEventArgs e)
        {
            CheckBox chkBox = (CheckBox)sender;

            var item = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            item.book_value = 1;            
        }

        private void chkbx_asset_management2__book_value_UnChecked(object sender, RoutedEventArgs e)
        {
            CheckBox chkBox = (CheckBox)sender;

            var item = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            item.book_value = 0;            
        }

        public void chkbx_asset_management2__book_value_RebindCheckBoxes()
        {
            //Uncheck if they haven't been set 
            var data = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            if (data.book_value == null)
                 return;
            decimal expectedNumber = 1;
            if (data.book_value.GetType().Equals(typeof(decimal)))
            {
                if (data.book_value.HasValue)
                {
                    chkbx_asset_management2__book_value_0.IsChecked = data.book_value.Equals(expectedNumber);
                }
                else
                {
                    chkbx_asset_management2__book_value_0.IsChecked = false;
                }
            }
        }

        private void radio_asset_management2__category_Checked(object sender, RoutedEventArgs e)
        {
            RadioButton rdButton = (RadioButton)sender;
            string data = rdButton.Content as string;
            
            var item = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            item.category = data;

        }
        public void radio_asset_management2__category_RebindRadioButtons()
        {
            var data = (asset_management2)asset_management2ViewSource.View.CurrentItem;

            if (data.category != null)
            {
                 switch (data.category)
                 {
                  case "Office Furniture":
                       radio_asset_management2__category_0.IsChecked = true;
                      break;
                  case "Computers":
                       radio_asset_management2__category_1.IsChecked = true;
                      break;
                  case "Telephones":
                       radio_asset_management2__category_2.IsChecked = true;
                      break;
                  case "-":
                       radio_asset_management2__category_3.IsChecked = true;
                      break;
                 }
             }
        }


        private void chkbx_asset_management2__category_Checked(object sender, RoutedEventArgs e)
        {
            CheckBox chkBox = (CheckBox)sender;

            string data = chkBox.Content as string;
            var item = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            if (item.category == null)
                return;
             if (!item.category.Contains(data))
            {
                item.category += "\n" + data;
            }
        }

        private void chkbx_asset_management2__category_UnChecked(object sender, RoutedEventArgs e)
        {
            CheckBox chkBox = (CheckBox)sender;

            string data = chkBox.Content as string;
            var item = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            if (item.category == null)
                return;
            if (item.category.Contains(data))
            {
                item.category.Replace("\n" + data, string.Empty);
            }
        }

        public void chkbx_asset_management2__category_RebindCheckBoxes()
        {
            //Uncheck if they haven't been set 
            chkbx_asset_management2__category_0.IsChecked = false;
            chkbx_asset_management2__category_1.IsChecked = false;
            chkbx_asset_management2__category_2.IsChecked = false;
            chkbx_asset_management2__category_3.IsChecked = false;
            var data = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            if (data.category == null)
                 return;
            string[] names = data.category.Split('\n');

            for (int i = 0; i < names.Length; i++)
            {
                
                switch (names[i].TrimStart(' '))
                {
                    case "Office Furniture":
                        chkbx_asset_management2__category_0.IsChecked = true;
                        break;
                    case "Computers":
                        chkbx_asset_management2__category_1.IsChecked = true;
                        break;
                    case "Telephones":
                        chkbx_asset_management2__category_2.IsChecked = true;
                        break;
                    case "-":
                        chkbx_asset_management2__category_3.IsChecked = true;
                        break;
                    //default:
                    //    throw new ApplicationException(" error ");
                }
                
            }
        }

        private void radio_asset_management2__category3_Checked(object sender, RoutedEventArgs e)
        {
            RadioButton rdButton = (RadioButton)sender;
            string data = rdButton.Content as string;
            
            var item = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            item.category = data;

        }
        public void radio_asset_management2__category3_RebindRadioButtons()
        {
            var data = (asset_management2)asset_management2ViewSource.View.CurrentItem;

            if (data.category != null)
            {
                 switch (data.category)
                 {
                  case "Office Furniture":
                       radio_asset_management2__category3_0.IsChecked = true;
                      break;
                  case "Computers":
                       radio_asset_management2__category3_1.IsChecked = true;
                      break;
                  case "Telephones":
                       radio_asset_management2__category3_2.IsChecked = true;
                      break;
                  case "-":
                       radio_asset_management2__category3_3.IsChecked = true;
                      break;
                 }
             }
        }


        private void chkbx_asset_management2__category4_Checked(object sender, RoutedEventArgs e)
        {
            CheckBox chkBox = (CheckBox)sender;

            string data = chkBox.Content as string;
            var item = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            if (item.category == null)
                return;
             if (!item.category.Contains(data))
            {
                item.category += "\n" + data;
            }
        }

        private void chkbx_asset_management2__category4_UnChecked(object sender, RoutedEventArgs e)
        {
            CheckBox chkBox = (CheckBox)sender;

            string data = chkBox.Content as string;
            var item = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            if (item.category == null)
                return;
            if (item.category.Contains(data))
            {
                item.category.Replace("\n" + data, string.Empty);
            }
        }

        public void chkbx_asset_management2__category4_RebindCheckBoxes()
        {
            //Uncheck if they haven't been set 
            chkbx_asset_management2__category4_0.IsChecked = false;
            chkbx_asset_management2__category4_1.IsChecked = false;
            chkbx_asset_management2__category4_2.IsChecked = false;
            chkbx_asset_management2__category4_3.IsChecked = false;
            var data = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            if (data.category == null)
                 return;
            string[] names = data.category.Split('\n');

            for (int i = 0; i < names.Length; i++)
            {
                
                switch (names[i].TrimStart(' '))
                {
                    case "Office Furniture":
                        chkbx_asset_management2__category4_0.IsChecked = true;
                        break;
                    case "Computers":
                        chkbx_asset_management2__category4_1.IsChecked = true;
                        break;
                    case "Telephones":
                        chkbx_asset_management2__category4_2.IsChecked = true;
                        break;
                    case "-":
                        chkbx_asset_management2__category4_3.IsChecked = true;
                        break;
                    //default:
                    //    throw new ApplicationException(" error ");
                }
                
            }
        }

     private void Bind_menu_asset_management2__category5()
        {
            var data = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            if (data.category != null)
            {
                string category = data.category.TrimStart(' ');
                int i = 0;
                foreach (XmlElement item in menu_asset_management2__category5.Items)
                {
                    if (item.InnerText.Equals(category))
                    {
                        menu_asset_management2__category5.SelectedIndex = i;
                        return;
                    }
                    i++;
                }
            }
        }

        private void menu_asset_management2__category5_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (asset_management2ViewSource != null)
            {
                 var item = (asset_management2)asset_management2ViewSource.View.CurrentItem;
                 if (item.category == null)
                 {
                    item.category = ((XmlElement)menu_asset_management2__category5.SelectedItem).InnerText;
                }
            }
        }
        private void radio_asset_management2__category6_Checked(object sender, RoutedEventArgs e)
        {
            RadioButton rdButton = (RadioButton)sender;
            string data = rdButton.Content as string;
            
            var item = (asset_management2)asset_management2ViewSource.View.CurrentItem;
            item.category = data;

        }
        public void radio_asset_management2__category6_RebindRadioButtons()
        {
            var data = (asset_management2)asset_management2ViewSource.View.CurrentItem;

            if (data.category != null)
            {
                 switch (data.category)
                 {
                  case "Office Furniture":
                       radio_asset_management2__category6_0.IsChecked = true;
                      break;
                  case "Computers":
                       radio_asset_management2__category6_1.IsChecked = true;
                      break;
                  case "Telephones":
                       radio_asset_management2__category6_2.IsChecked = true;
                      break;
                  case "Table":
                       radio_asset_management2__category6_3.IsChecked = true;
                      break;
                  case "Chair":
                       radio_asset_management2__category6_4.IsChecked = true;
                      break;
                  case "Router":
                       radio_asset_management2__category6_5.IsChecked = true;
                      break;
                 }
             }
        }


        private void chkbx_maintenance_record__maint_condition3_Checked(object sender, RoutedEventArgs e)
        {
            CheckBox chkBox = (CheckBox)sender;

            string data = chkBox.Content as string;
            var item = (maintenance_record)maintenance_recordViewSource.View.CurrentItem;
            if (item.maint_condition3 == null)
                return;
             if (!item.maint_condition3.Contains(data))
            {
                item.maint_condition3 += "\n" + data;
            }
        }

        private void chkbx_maintenance_record__maint_condition3_UnChecked(object sender, RoutedEventArgs e)
        {
            CheckBox chkBox = (CheckBox)sender;

            string data = chkBox.Content as string;
            var item = (maintenance_record)maintenance_recordViewSource.View.CurrentItem;
            if (item.maint_condition3 == null)
                return;
            if (item.maint_condition3.Contains(data))
            {
                item.maint_condition3.Replace("\n" + data, string.Empty);
            }
        }

        public void chkbx_maintenance_record__maint_condition3_RebindCheckBoxes()
        {
            //Uncheck if they haven't been set 
            var data = (maintenance_record)maintenance_recordViewSource.View.CurrentItem;
            if (data.maint_condition3 == null)
                 return;
            string[] names = data.maint_condition3.Split('\n');

            for (int i = 0; i < names.Length; i++)
            {
                
                
            }
        }

        private void radio_maintenance_record__maint_condition4_Checked(object sender, RoutedEventArgs e)
        {
            RadioButton rdButton = (RadioButton)sender;
            string data = rdButton.Content as string;
            
            var item = (maintenance_record)maintenance_recordViewSource.View.CurrentItem;
            item.maint_condition4 = data;

        }
        public void radio_maintenance_record__maint_condition4_RebindRadioButtons()
        {
            var data = (maintenance_record)maintenance_recordViewSource.View.CurrentItem;

            if (data.maint_condition4 != null)
            {
             }
        }


    }
}
