using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using System.Windows.Markup;
using System.Xml;

namespace Assets002ns
{
    /// <summary>
    /// Interaction logic for maintenance_recordWindow.xaml
    /// </summary>
    public partial class maintenance_recordWindow : WindowBase
    {

        public maintenance_recordWindow()
        {
            InitializeComponent();
        }

        private Assets002ns.AssetsDBEntities assetsdbEntities = null;
        System.Windows.Data.CollectionViewSource maintenance_recordViewSource = null;
        System.Data.Objects.ObjectQuery<Assets002ns.maintenance_record> maintenance_recordQuery = null;
        System.Windows.Data.CollectionViewSource asset_management2ViewSource = null;
        System.Data.Objects.ObjectQuery<Assets002ns.asset_management2> asset_management2Query = null;

        private System.Data.Objects.ObjectQuery<Assets002ns.maintenance_record>Getmaintenance_recordQuery(AssetsDBEntities assetsdbEntities)
          {
              // Auto generated code
              System.Data.Objects.ObjectQuery<Assets002ns.maintenance_record> maintenance_recordQuery = assetsdbEntities.maintenance_record;
              //Update the query to include related table data in "asset_management2". You can modify this code as needed.
              maintenance_recordQuery = maintenance_recordQuery.Include("asset_management2"); // Returns an ObjectQuery.
              return maintenance_recordQuery;
          }

        private System.Data.Objects.ObjectQuery<asset_management2>Getasset_management2Query(AssetsDBEntities assetsdbEntities)
          {
              // Auto generated code
              System.Data.Objects.ObjectQuery<asset_management2> asset_management2Query = assetsdbEntities.asset_management2;
              asset_management2Query = asset_management2Query.Include("maintenance_record"); // Returns an ObjectQuery.
              return asset_management2Query;
          }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            assetsdbEntities = new Assets002ns.AssetsDBEntities();
            // Load data into maintenance_record. You can modify this code as needed.
            maintenance_recordViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("maintenance_recordViewSource")));
            maintenance_recordQuery = this.Getmaintenance_recordQuery(assetsdbEntities);
            maintenance_recordViewSource.Source = maintenance_recordQuery.Execute(System.Data.Objects.MergeOption.PreserveChanges);
            asset_management2ViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("asset_management2ViewSource")));
            asset_management2Query = this.Getasset_management2Query(assetsdbEntities);
            asset_management2ViewSource.Source = asset_management2Query.Execute(System.Data.Objects.MergeOption.PreserveChanges);
            this.ReBind();
        }
        protected internal override int TotalRecords
        {
            get 
            {
                var currentTable = assetsdbEntities.maintenance_record.AsQueryable();
                int maxRecords = currentTable.Count();
                return maxRecords;
            }
        }
        
        protected internal override double CurrentRecordPosition
        {
            get
            {
                return (double)maintenance_recordViewSource.View.CurrentPosition;
            }

            set
            {
                int newPosition = (int)value;
                var currentTable = assetsdbEntities.maintenance_record.AsQueryable();   
                int maxRecords = currentTable.Count() - 1; 
                
                if(newPosition > maxRecords)
                {
                    newPosition = maxRecords;
                }

                maintenance_recordViewSource.View.MoveCurrentToPosition(newPosition);
                NotifyPropertyChanged("CurrentRecordPosition");
            }
        }
        protected internal override void SaveRecords()
        {
            try
            {
                this.assetsdbEntities.SaveChanges();

            }
            catch (Exception)
            {
                //Error handling                
                throw;
            }
        }

        protected internal override void NewRecord()
        {
            try
            {
                var entity = assetsdbEntities.CreateObject<maintenance_record>();
                assetsdbEntities.AddTomaintenance_record(entity);

            }
            catch (Exception)
            {
                //Error Handling
                throw;
            } 
            
            this.SaveRecords(); 
            maintenance_recordViewSource.Source = maintenance_recordQuery.Execute(System.Data.Objects.MergeOption.PreserveChanges);
            maintenance_recordViewSource.View.MoveCurrentToLast();

            NotifyPropertyChanged("TotalRecords");
        }


        protected internal override void DeleteCurrentRecord()
        {
            try
            {
                var entity = maintenance_recordViewSource.View.CurrentItem;
                assetsdbEntities.DeleteObject(entity);

            }
            catch (Exception)
            {
                //Error Handling        
                throw;
            }                    
            this.SaveRecords();
            maintenance_recordViewSource.View.Refresh();
            NotifyPropertyChanged("TotalRecords");
        }

        protected internal override void MoveToNextRecord()
        {
            if (maintenance_recordViewSource.View.CurrentPosition < ((CollectionView)maintenance_recordViewSource.View).Count - 1)
            { 
                maintenance_recordViewSource.View.MoveCurrentToNext(); 
            }
                this.SaveRecords();
            NotifyPropertyChanged("CurrentRecordPosition");
        }

        protected internal override void MoveToPreviousRecord()
        {
            if (maintenance_recordViewSource.View.CurrentPosition > 0)
            {
                maintenance_recordViewSource.View.MoveCurrentToPrevious();
            }
                this.SaveRecords();
            NotifyPropertyChanged("CurrentRecordPosition");
        }

        protected internal override void ReBind() 
        {
        }

    }
}
